<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/28/2003 *
 * ===================                          Last change: 07/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-unlock_emails.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Unlock ordered emails                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Werbebuchungen freigeben                         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Check for mails
$result_main = SQL_QUERY("SELECT
	`id`,`sender`,`subject`,`payment_id` AS `payment`,`timestamp`,`url`,`target_send`,`cat_id` AS category
FROM
	`{?_MYSQL_PREFIX?}_pool`
WHERE
	`data_type`='ADMIN'
ORDER BY
	`timestamp` ASC", __FILE__, __LINE__);

if ((SQL_NUMROWS($result_main) > 0) || (isPostRequestParameterSet('lock'))) {
	if (isPostRequestParameterSet('accept')) {
		if (countPostSelection() > 0) {
			// Accept mail orders
			foreach (postRequestParameter('sel') as $id => $value) {
				// Secure id number
				$id = bigintval($id);

				// Order placed in queue...
				$result = SQL_QUERY_ESC("SELECT
	po.url, po.subject, po.sender, pay.payment, po.payment_id
FROM
	`{?_MYSQL_PREFIX?}_pool` AS po
INNER JOIN
	`{?_MYSQL_PREFIX?}_payments` AS pay
ON
	po.payment_id=pay.id
WHERE
	po.id=%s
LIMIT 1",
					array($id), __FILE__, __LINE__);

				// Update wents fine?
				if (SQL_NUMROWS($result) == 1) {
					// Load data
					$content = SQL_FETCHARRAY($result);

					// Free result
					SQL_FREERESULT($result);

					// Is the surfbar installed?
					// @TODO Rewrite these if-blocks to a filter
					if ((isExtensionActive('surfbar')) && (getConfig('surfbar_migrate_order') == 'Y')) {
						// Then "migrate" the URL to the surfbar
						SURFBAR_ADMIN_MIGRATE_URL($content['url'], $content['sender']);
					} // END - if

					// Check for bonus extension version >= 0.4.4 for the order bonus
					if ((getExtensionVersion('bonus') >= '0.4.4') && (getConfig('bonus_active') == 'Y')) {
						// Add points directly
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `bonus_order`=`bonus_order`+".getConfig('bonus_order')." WHERE `userid`=%s LIMIT 1",
							array(bigintval($content['sender'])), __FILE__, __LINE__);

						// Subtract bonus points from system
						handleBonusPoints(getConfig('bonus_order'));
					} // END - if

					// Load email template
					$message_user = loadEmailTemplate('order-accept', $content, $content['sender']);

					// Send email
					sendEmail($content['sender'], getMessage('MEMBER_ORDER_ACCEPTED'), $message_user);

					// Unlock selected email
					SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `data_type`='NEW' WHERE `id`=%s AND `data_type`='ADMIN' LIMIT 1",
						array($id), __FILE__, __LINE__);
				} // END - if
			} // END - foreach

			// Set message
			$message = getMessage('ADMIN_MAILS_ACTIVATED');
		} else {
			// Nothing checked!
			$message = getMessage('ADMIN_MAILS_NOTHING_CHECKED');
		}

		// Mails unlocked for mail delivery
		loadTemplate('admin_settings_saved', false, $message);
	} elseif (isPostRequestParameterSet(('reject'))) {
		if (countPostSelection() > 0) {
			// Reject mail orders
			$OUT = ''; $SW = 2;
			foreach (postRequestParameter('sel') as $id => $value) {
				// Secure id number
				$id = bigintval($id);

				// Load URL and subject from pool
				$result = SQL_QUERY_ESC("SELECT `url`, `subject`, `sender` FROM `{?_MYSQL_PREFIX?}_pool` WHERE `id`=%s LIMIT 1",
					array($id), __FILE__, __LINE__);

				// Load data
				$content = SQL_FETCHARRAY($result);

				// Free result
				SQL_FREERESULT($result);

				// Load email template and send it away
				$message_user = loadEmailTemplate('order-reject', $content, $content['sender']);
				sendEmail($content['sender'], getMessage('MEMBER_ORDER_REJECTED'), $message_user);

				// If you do not enter an URL to redirect to, your URL will be set!
				if ((!isPostRequestParameterSet('redirect')) || (postRequestParameter('redirect') == 'http://')) setPostRequestParameter('redirect', getConfig('URL'));

				// Redirect URL
				SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET url='%s', `data_type`='NEW' WHERE `id`=%s LIMIT 1",
					array(postRequestParameter('redirect'), $id),__FILE__, __LINE__);

				// Prepare data for the row template
				$content = array(
					'sw'  => $SW,
					'id'  => $id,
					'url' => postRequestParameter('url', $id),
				);

				// Load row template and switch colors
				$OUT .= loadTemplate('admin_unlock_emails_redir_row', true, $content);
				$SW = 3 - $SW;
			}

			// Load main template
			loadTemplate('admin_unlock_emails_redir', false, $OUT);
		} else {
			// Nothing selected
			loadTemplate('admin_settings_saved', false, getMessage('ADMIN_MAILS_NOTHING_CHECKED'));
		}
	} elseif ((isPostRequestParameterSet('lock')) && (countPostSelection() > 0) && (getConfig('url_blacklist') == 'Y')) {
		// Lock URLs
		foreach (postRequestParameter('sel') as $id => $url) {
			// Secure id number
			$id = bigintval($id);

			// Lookup in blacklist
			$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_url_blacklist` WHERE `url`='%s' LIMIT 1",
				array($url), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == '0') {
				// Did not find a record so we can add it... :)
				SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_url_blacklist` (`url`,`pool_id`) VALUES ('%s',%s)",
					array($url, $id), __FILE__, __LINE__);
			} // END - if

			// Free memory
			SQL_FREERESULT($result);
		} // END - foreach

		// Output message
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_URLS_BLOCKED'));
	} elseif ((!isPostRequestParameterSet('lock')) && (!isPostRequestParameterSet('accept')) && (!isPostRequestParameterSet('reject'))) {
		// Mail orders are in pool so we can display them
		$OUT = ''; $SW = 2;
		while ($content = SQL_FETCHARRAY($result_main)) {
			// Prepare data for the template
			$content = array(
				'sw'          => $SW,
				'id'          => $content['id'],
				'sender'      => $content['sender'],
				'u_link'      => generateUserProfileLink($content['sender']),
				'subject'     => $content['subject'],
				'tester'      => generateFrametesterUrl($content['url']),
				'url'         => $content['url'],
				'cat_title'   => str_replace("\"", '&quot;', getCategory($content['category'])),
				'cat_link'    => $content['category'],
				'pay_title'   => str_replace("\"", '&quot;', getPaymentTitlePrice($content['payment'], true)),
				'pay_link'    => $content['payment'],
				'timestamp'   => generateDateTime($content['timestamp'], 2),
				'target_send' => $content['target_send'],
			);

			// Load row template and switch colors
			$OUT .= loadTemplate('admin_unlock_emails_row', true, $content);
			$SW = 3 - $SW;
		} // END - while

		// Free memory
		SQL_FREERESULT($result_main);

		// Remember in array
		$content['rows'] = $OUT;

		// Load main template
		loadTemplate('admin_unlock_emails', false, $content);
	} elseif ((isPostRequestParameterSet('lock')) && (getConfig('url_blacklist') != 'Y')) {
		// URL blacklist not activated
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_URL_BLACKLIST_DISABLED'));
	} else {
		// Wrong call!
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_WRONG_CALL'));
	}
} else {
	// No mail orders fond
	loadTemplate('admin_settings_saved', false, getMessage('ADMIN_NO_MAILS_IN_POOL'));
}

// [EOF]
?>
